## kseexpr 4.0.4.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020-2021 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.8.0)

# option() honors normal variables. Needed for LLVM 10.
if (POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()
# Minimum for SeExpr is 11. LLVM (if used) may need 14.
# LLVM with Clang < 8 crashes on compile: https://github.com/andreasfertig/cppinsights/issues/56#issuecomment-408674466
set(CMAKE_CXX_STANDARD 14)

## project name & version
project(KSeExpr
    VERSION "4.0.4.0"
    DESCRIPTION "An embeddable expression evaluation engine for Krita"
)

message(STATUS "Welcome to ${CMAKE_PROJECT_NAME} ${CMAKE_PROJECT_VERSION} !")

enable_testing()

## Silence installation messages
set(CMAKE_INSTALL_MESSAGE LAZY)

# macros
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
LIST (APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
include(macros)
include(CheckCXXSourceCompiles)
include(FeatureSummary)

# Default installation prefix
if (NOT DEFINED FLAVOR)
    set(FLAVOR "optimize" CACHE STRING "Build flavor")
endif()

## Choose build options
# Disney specific method of choosing variant
if (${FLAVOR} STREQUAL "optimize")
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "type of build" FORCE)
endif()

if (${FLAVOR} STREQUAL "debug")
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "type of build" FORCE)
endif()

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    execute_process(
        COMMAND sh -c "echo `uname -s`-`uname -r | cut -d- -f1`-`uname -m`"
        OUTPUT_VARIABLE VARIANT_DIRECTORY OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(CMAKE_INSTALL_PREFIX
        "${CMAKE_SOURCE_DIR}/${VARIANT_DIRECTORY}-${FLAVOR}"
        CACHE PATH "Installation prefix" FORCE)
endif()

message(STATUS "CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
message(STATUS "CMAKE_INSTALL_LIBDIR = ${CMAKE_INSTALL_LIBDIR}")

# Configuration options
option(ENABLE_LLVM_BACKEND "Whether to build with LLVM backend" FALSE)
add_feature_info(LLVMBackend ENABLE_LLVM_BACKEND "Build the LLVM backend of KSeExpr")
option(ENABLE_QT5 "Whether to use Qt5" TRUE)
add_feature_info(KSeExprUI ENABLE_QT5 "Build the KSeExprUI widget library")
option(BUILD_UTILS "Whether to build the utilities" FALSE)
add_feature_info(Utils BUILD_UTILS "Build the utilities")
option(BUILD_DEMOS "Whether to build the demos" FALSE)
add_feature_info(Demos BUILD_DEMOS "Build the demos")
option(BUILD_DOC "Whether to build the documentation" FALSE)
add_feature_info(Docs BUILD_DOC "Build the documentation")
option(BUILD_TESTS "Whether to build the tests" FALSE)
add_feature_info(Tests BUILD_TESTS "Build the tests")
option(ENABLE_SLOW_TESTS "Whether to enable slow tests" FALSE)
add_feature_info(SlowTests ENABLE_SLOW_TESTS "Enables slow tests")
option(USE_PREGENERATED_FILES "Whether to use the bundled pregenerated parser files" FALSE)
add_feature_info(PregeneratedFiles USE_PREGENERATED_FILES "Build the language parser using the bundled, pregenerated files")
option(ENABLE_PERFORMANCE_STATS "Whether to print performance stats across KSeExpr" FALSE)
add_feature_info(PerformanceStats ENABLE_PERFORMANCE_STATS "Print performance stats across KSeExpr")

# Package lookup

find_package(Doxygen)
set_package_properties(Doxygen PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the documentation")
find_package(ECM 5.52.0 NO_MODULE)
set_package_properties(ECM PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Enables translations (if bundled) and automatic sanitizer support")
find_package(KF5I18n 5.52.0)
set_package_properties(KF5I18n PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Enables detection of fallback languages in KDE apps")
find_package(GTest)
set_package_properties(GTest PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed for building the tests")
find_package(PNG)
set_package_properties(PNG PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to support image file output in demos and tests")
find_package(Python3)
set_package_properties(Python3 PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed for running some tests")
find_package(BISON)
set_package_properties(BISON PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build KSeExpr's language parser from source")
find_package(FLEX)
set_package_properties(FLEX PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build KSeExpr's language parser from source")
find_program(SED_EXE sed)
set_package_properties(SED_EXE PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build KSeExpr's language parser from source")

if (ECM_FOUND)
    set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})
    if (FLAVOR STREQUAL "debug")
        message(STATUS "ECM sanitizer support is available.")
        include(ECMEnableSanitizers)
    endif()

    if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/po")
        option(BUILD_TRANSLATIONS "Whether to include translations" TRUE)
        add_feature_info(i18n BUILD_TRANSLATIONS "Build and embed translations")
    endif ()
endif ()

if (ENABLE_LLVM_BACKEND)
    find_package(LLVM)
    set_package_properties(LLVM PROPERTIES
                        TYPE OPTIONAL
                        PURPOSE "Needed for building the LLVM-based script backend")
    if (NOT LLVM_FOUND OR LLVM_VERSION VERSION_LESS 3.8.0)
        set(ENABLE_LLVM_BACKEND off)
        message(STATUS "Not building with LLVM, version must be >= 3.8.0")
    else()
        set(SEEXPR_ENABLE_LLVM 1)

        message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${LLVM_DIR}")
        include(LLVM-Config)
        include(LLVMConfig)
        include(HandleLLVMOptions)

        message(STATUS "LLVM_DEFINITIONS =" ${LLVM_DEFINITIONS})
        message(STATUS "LLVM_INCLUDE_DIRS =" ${LLVM_INCLUDE_DIRS})
        message(STATUS "LLVM_LIBRARY_DIR =" ${LLVM_LIBRARY_DIR})
        message(STATUS "LLVM_PACKAGE_VERSION =" ${LLVM_PACKAGE_VERSION})

        # construct library names

        message(STATUS "Detected processor: ${CMAKE_SYSTEM_PROCESSOR}")
        if(CMAKE_SYSTEM_PROCESSOR MATCHES "amd64.*|x86_64.*|AMD64.*")
            set(KSeExpr_PLATFORM_CODEGEN_LIBS
                X86CodeGen
                X86AsmParser)
        elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "i686.*|i386.*|x86.*")
            set(KSeExpr_PLATFORM_CODEGEN_LIBS
                X86CodeGen
                X86AsmParser)
        elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*|arm64.*|ARM64.*)")
            set(KSeExpr_PLATFORM_CODEGEN_LIBS
                AArch64CodeGen
                AArch64AsmParser)
        elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*)")
            set(KSeExpr_PLATFORM_CODEGEN_LIBS
                ARMCodeGen
                ARMAsmParser)
        else()
            message(ERROR "Unknown processor, unable to set LLVM codegen targets")
        endif()

        if (LLVM IN_LIST LLVM_AVAILABLE_LIBS)
            message(STATUS "Shared libLLVM is available, using it.")
            set(LLVM_LIB LLVM)
        else()
            message(STATUS "Shared libLLVM is not available, falling back to static linkage.")
            llvm_map_components_to_libnames(LLVM_LIB
                Interpreter
                MCJIT
                ObjCARCOpts
                Passes
                ${KSeExpr_PLATFORM_CODEGEN_LIBS}
            )
        endif()

        message(STATUS "LLVM_LIB = ${LLVM_LIB}")
    endif()
endif()

## Setup platform specific helper defines build variants
if (WIN32)
    add_definitions(-DSEEXPR_WIN32)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_compile_definitions(_USE_MATH_DEFINES)
else()
    add_definitions(-Wall -Wextra -Wno-unused-parameter)

    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    if (APPLE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-date-time")
    endif()
endif()

# Set to release if nothing else defined
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

if (ENABLE_QT5)
    find_package(Qt5 5.9.0 COMPONENTS Core Gui Widgets REQUIRED)
    set_package_properties(Qt5 PROPERTIES
                            TYPE REQUIRED
                            PURPOSE "Required if you're building KSeExprUI")
    message(STATUS "Qt5 Enabled")
endif()

## Make modules able to see seexpr library
# Setup environment variable to link seexpr
set(SEEXPR_LIBRARIES KSeExpr)
set(SEEXPR_LLVM_LIBRARIES KSeExprLLVM)
set(SEEXPR_EDITOR_LIBRARIES KSeExprUI)

# make it so seexpr can be found
include_directories(BEFORE ${CMAKE_SOURCE_DIR}/src)

if (ENABLE_PERFORMANCE_STATS)
    add_definitions(-DSEEXPR_PERFORMANCE)
endif()

## Traverse subdirectories
add_subdirectory(src/KSeExpr)
if (ENABLE_QT5)
    add_subdirectory(src/KSeExprUI)
endif()
if (BUILD_UTILS)
    add_subdirectory(src/utils)
endif()
if (BUILD_DEMOS)
    add_subdirectory(src/demos)
endif()
if (BUILD_DOC)
    add_subdirectory(src/doc)
endif()
if (BUILD_TESTS)
    add_subdirectory(src/tests)
endif()

# cmake packaging -- this is done after adding subdirectories so that
# all exported targets are found by export() below.
configure_file("cmake/kseexpr.pc.in" "kseexpr.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kseexpr.pc"
    COMPONENT devel DESTINATION share/pkgconfig)

write_basic_package_version_file("kseexpr-config-version.cmake" VERSION ${${PROJECT_NAME}_VERSION} COMPATIBILITY SameMajorVersion)

configure_package_config_file(
    "cmake/kseexpr-config.cmake" "kseexpr-config.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
    PATH_VARS CMAKE_INSTALL_PREFIX CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR)
install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/kseexpr-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/kseexpr-config-version.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
install(EXPORT ${PROJECT_NAME}Targets
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/KSeExpr/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

# Source files for llvm supported library and interpreter library
set(KSeExpr_HEADERS
        Context.h
        Curve.h
        ErrorCode.h
        Evaluator.h
        ExprBuiltins.h
        ExprEnv.h
        Expression.h
        ExprFunc.h
        ExprFuncStandard.h
        ExprFuncX.h
        ExprLLVM.h
        ExprLLVMAll.h
        ExprMultiExpr.h
        ExprNode.h
        ExprParser.h
        ExprPatterns.h
        ExprType.h
        ExprWalker.h
        Interpreter.h
        Noise.h
        NoiseTables.h
        PerformanceTimer.h
        StringUtils.h
        Timer.h
        TypePrinter.h
        Utils.h
        VarBlock.h
        Vec.h
    )

set(KSeExpr_SOURCES
        Context.cpp
        Curve.cpp
        ExprBuiltins.cpp
        ExprEnv.cpp
        Expression.cpp
        ExprFunc.cpp
        ExprFuncStandard.cpp
        ExprFuncX.cpp
        ExprLLVMCodeGeneration.cpp
        ExprMultiExpr.cpp
        ExprNode.cpp
        ExprWalker.cpp
        Interpreter.cpp
        Noise.cpp
        Utils.cpp
    )

set_source_files_properties("ExprBuiltins.cpp" PROPERTIES COMPILE_DEFINITIONS "__STDC_LIMIT_MACROS")


## Test charconv and dynamic dispatch support
check_cxx_source_compiles("
  #include <charconv>
  #include <string>

  int main()
  {
    std::string test{ \"4.5\" };
    double d;
    auto [p, ec] = std::from_chars(test.data(), test.data() + test.size(), d);
    return ec != std::errc();
  }
" KSeExpr_HAVE_CHARCONV_WITH_DOUBLES)

check_cxx_source_compiles("
    [[gnu::target(\"default\")]] int main() { return 4; }
    [[gnu::target(\"sse4.1\")]] int main() { return 5; }
" KSeExpr_HAVE_DYNAMIC_DISPATCH)

BuildParserScanner(KSeExpr ExprParserLex ExprParser SeExpr parser_cpp)

if (NOT WIN32)
    add_library(KSeExpr SHARED ${KSeExpr_SOURCES} ${parser_cpp})
    if (NOT APPLE)
        set_source_files_properties(interpreter.cpp PROPERTIES COMPILE_OPTIONS "-rdynamic")
    endif()
    target_link_libraries(KSeExpr "dl")
else()
    add_library(KSeExpr STATIC ${KSeExpr_SOURCES} ${parser_cpp})
endif()

target_include_directories(KSeExpr
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    INTERFACE $<INSTALL_INTERFACE:include>
)

set_property(TARGET KSeExpr PROPERTY VERSION ${KSeExpr_VERSION})
set_property(TARGET KSeExpr PROPERTY SOVERSION ${KSeExpr_VERSION_MAJOR})
set_property(TARGET KSeExpr PROPERTY
             INTERFACE_KSeExpr_MAJOR_VERSION ${KSeExpr_VERSION_MAJOR})
set_property(TARGET KSeExpr APPEND PROPERTY
             COMPATIBLE_INTERFACE_STRING ${KSeExpr_VERSION_MAJOR})

generate_export_header(KSeExpr)

configure_file("ExprConfig.h.in" "ExprConfig.h")

## Install binary and includes
install(TARGETS KSeExpr
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    EXPORT ${PROJECT_NAME}Targets
)

install(FILES
    ${KSeExpr_HEADERS}
    ${KSeExpr_LLVM_HEADERS}
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/kseexpr_export.h>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/ExprConfig.h>
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/KSeExpr"
)

if (ENABLE_LLVM_BACKEND)
    add_definitions(${LLVM_DEFINITIONS})

    target_include_directories(${SEEXPR_LIBRARIES} PUBLIC ${LLVM_INCLUDE_DIRS})

    if(LLVM_VERSION VERSION_GREATER_EQUAL 10)
        # LLVM >= 10 moved to C++ 14.
        target_compile_features(${SEEXPR_LIBRARIES} PUBLIC cxx_std_14)
    else()
        target_compile_features(${SEEXPR_LIBRARIES} PUBLIC cxx_std_11)
    endif()

    target_link_libraries(KSeExpr ${LLVM_LIB})
endif()

=== src/KSeExprUI/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020-2021 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

if (EXISTS "/usr/share/apps/cmake/modules")
    # Needed for some versions of CMake, which only look in version-specific module path
    list(APPEND CMAKE_MODULE_PATH "/usr/share/apps/cmake/modules")
endif()

if (Qt5_FOUND)
    # Adding Krita's definitions to make headers automatically compatible. -amyspark
    add_definitions(
        -DQT_USE_QSTRINGBUILDER
        -DQT_STRICT_ITERATORS
        -DQT_NO_SIGNALS_SLOTS_KEYWORDS
        -DQT_NO_URL_CAST_FROM_STRING
        -DQT_USE_FAST_CONCATENATION
        -DQT_USE_FAST_OPERATOR_PLUS
    )

    if (CMAKE_COMPILER_IS_GNUCXX)
        add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-Wno-suggest-override> -Wextra)
    endif()

    BuildParserScanner(KSeExprUI ExprSpecParserLex ExprSpecParser ExprSpec
                       editor_parser_cpp)

    set(EDITOR_MOC_HDRS
            ErrorMessages.h
            ExprAddDialog.h
            ExprBrowser.h
            ExprColorCurve.h
            ExprColorSwatch.h
            ExprCompletionModel.h
            ExprControlCollection.h
            ExprControl.h
            ExprCurve.h
            ExprEditor.h
            ExprFileDialog.h
            ExprPopupDoc.h
            ExprTextEdit.h
        )

    set(EDITOR_ADDITIONAL_HEADERS
            Debug.h
            BasicExpression.h
            ControlSpec.h
            Editable.h
            EditableExpression.h
            ExprHighlighter.h
            ExprSpecType.h
            Utils.h
    )

    set(EDITOR_CPPS
            BasicExpression.cpp
            ControlSpec.cpp
            Debug.cpp
            Editable.cpp
            EditableExpression.cpp
            ErrorMessages.cpp
            ExprAddDialog.cpp
            ExprBrowser.cpp
            ExprColorCurve.cpp
            ExprColorSwatch.cpp
            ExprCompletionModel.cpp
            ExprControl.cpp
            ExprControlCollection.cpp
            ExprCurve.cpp
            ExprEditor.cpp
            ExprFileDialog.cpp
            ExprHighlighter.cpp
            ExprPopupDoc.cpp
            ExprTextEdit.cpp
            Utils.cpp
    )

    qt5_wrap_cpp(EDITOR_MOC_SRCS ${EDITOR_MOC_HDRS})

    if (BUILD_TRANSLATIONS)
        include(ECMPoQmTools)
        ecm_install_po_files_as_qm("${CMAKE_SOURCE_DIR}/po")

        if (KF5I18n_FOUND)
            add_definitions(-DKSeExpr_HAVE_I18N_FALLBACK_LANGUAGES_DETECTION)
        endif()

        # ecm_create_qm_loader(KSeExprUI_QM_LOADER seexpr2_qt)
        set(KSeExprUI_QM_LOADER "ECMQmLoader-seexpr2_qt.cpp")
        set(EDITOR_CPPS
            ${EDITOR_CPPS}
            ${KSeExprUI_QM_LOADER})
    endif()

    if (NOT WIN32)
        add_library(KSeExprUI SHARED ${EDITOR_CPPS} ${EDITOR_MOC_SRCS}
                    ${editor_parser_cpp})
    else ()
        add_library(KSeExprUI STATIC ${EDITOR_CPPS} ${EDITOR_MOC_SRCS}
                ${editor_parser_cpp})
    endif ()

    set_property(TARGET KSeExprUI PROPERTY VERSION ${KSeExpr_VERSION})
    set_property(TARGET KSeExprUI PROPERTY SOVERSION ${KSeExpr_VERSION_MAJOR})
    set_property(TARGET KSeExprUI PROPERTY
                 INTERFACE_KSeExprUI_MAJOR_VERSION ${KSeExpr_VERSION_MAJOR})
    set_property(TARGET KSeExprUI APPEND PROPERTY
                 COMPATIBLE_INTERFACE_STRING ${KSeExpr_VERSION_MAJOR})

    target_include_directories(KSeExprUI
        PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
        PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        INTERFACE $<INSTALL_INTERFACE:include>
    )
    target_link_libraries(KSeExprUI PUBLIC KSeExpr)

    target_link_libraries(KSeExprUI PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
    )

    if (KF5I18n_FOUND)
        target_link_libraries(KSeExprUI PUBLIC KF5::I18n)
    endif()

    ## Install library and includes
    install(TARGETS KSeExprUI EXPORT ${PROJECT_NAME}Targets DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install(FILES
        ${EDITOR_MOC_HDRS}
        ${EDITOR_ADDITIONAL_HEADERS}
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/KSeExprUI"
    )
endif()

=== src/demos/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

add_executable(asciiGraph2 "asciiGraph.cpp")
target_link_libraries(asciiGraph2 KSeExpr)
install(TARGETS asciiGraph2 DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(asciiCalc2 "asciiCalculator.cpp")
target_link_libraries(asciiCalc2 KSeExpr)
install(TARGETS asciiCalc2 DESTINATION ${CMAKE_INSTALL_BINDIR})

add_subdirectory(imageSynth)
add_subdirectory(imageEditor)

=== src/doc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

if (DOXYGEN_FOUND AND NOT WIN32)
    configure_file("Doxyfile.in" "Doxyfile" @ONLY)
    file(GLOB (DOCUMENTED_FILES ../KSeExpr/*.h))

    set(DOXYGEN ${DOXYGEN_EXECUTABLE})
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doxygen.txt
        COMMAND ${DOXYGEN} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile >doxygen.txt
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS Doxyfile.in)

    add_custom_target(doc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxygen.txt)

    install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html/" DESTINATION ${CMAKE_INSTALL_DOCDIR})
    install(FILES userdoc.html DESTINATION ${CMAKE_INSTALL_DOCDIR} RENAME SeExpressions.html)

    file(GLOB "*.png" PNG_FILES)
    install(FILES ${PNG_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif()

=== src/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later


if (GTest_FOUND AND PNG_FOUND AND Python3_FOUND)
    message("-- Found PNG library: " ${PNG_LIBRARIES})
    message("-- Found Python executable: " ${Python3_EXECUTABLE})

    set(TEST_DEST "share/test/KSeExpr")

    # generate test cases for example developer expressions
    set (GENERATE_SCRIPT "${CMAKE_CURRENT_SOURCE_DIR}/genImageTestFile.py")
    set (EXAMPLE_DIR ${CMAKE_INSTALL_PREFIX}/share/KSeExpr/demos/imageSynth/examples)
    if (EXISTS ${EXAMPLE_DIR})
        set (EXAMPLE_TESTS "testSeExprExamples.cpp")
        add_custom_command(
            SOURCE ${EXAMPLE_DIR}
            COMMAND ${GENERATE_SCRIPT}
            ARGS "${EXAMPLE_DIR}" "${EXAMPLE_TESTS}"
            OUTPUT ${EXAMPLE_TESTS}
            DEPENDS ${GENERATE_SCRIPT} ${EXAMPLE_DIR})
    endif()

    add_executable(basicTests "basic.cpp")
    target_include_directories(basicTests PRIVATE ${GTEST_INCLUDE_DIR})
    target_link_libraries(basicTests KSeExpr GTest::GTest GTest::Main)
    install(TARGETS basicTests DESTINATION ${TEST_DEST})
    add_test(NAME basicTests COMMAND basicTests)

    add_executable(imageTests "imageTests.cpp" ${EXAMPLE_TESTS})
    target_include_directories(imageTests PRIVATE ${PNG_INCLUDE_DIR})
    target_include_directories(imageTests PRIVATE ${GTEST_INCLUDE_DIR})
    target_link_libraries(imageTests KSeExpr GTest::GTest GTest::Main ${PNG_LIBRARIES})
    install(TARGETS imageTests DESTINATION ${TEST_DEST})
    add_test(NAME imageTests COMMAND imageTests)

    add_executable(stringTests "string.cpp")
    target_include_directories(stringTests PRIVATE ${GTEST_INCLUDE_DIR})
    target_link_libraries(stringTests KSeExpr GTest::GTest GTest::Main)
    install(TARGETS stringTests DESTINATION ${TEST_DEST})
    add_test(NAME stringTests COMMAND stringTests)

    add_executable(typeTests "typeTests.cpp")
    target_include_directories(typeTests PRIVATE ${GTEST_INCLUDE_DIR})
    target_link_libraries(typeTests KSeExpr GTest::GTest GTest::Main)
    install(TARGETS typeTests DESTINATION ${TEST_DEST})
    add_test(NAME typeTests COMMAND typeTests)

    add_executable(typePrinter "TypePrinter.cpp")
    target_link_libraries(typePrinter KSeExpr)
    install(TARGETS typePrinter DESTINATION ${TEST_DEST})

    add_executable(multiTests "multiTests.cpp")
    target_include_directories(multiTests PRIVATE ${GTEST_INCLUDE_DIR})
    target_link_libraries(multiTests KSeExpr GTest::GTest GTest::Main)
    install(TARGETS multiTests DESTINATION ${TEST_DEST})
    add_test(NAME multiTests COMMAND multiTests)

    add_executable(dirtSimple "dirtSimple.cpp")
    target_include_directories(dirtSimple PRIVATE ${PNG_INCLUDE_DIR})
    target_link_libraries(dirtSimple KSeExpr ${PNG_LIBRARIES})
    install(TARGETS dirtSimple DESTINATION ${TEST_DEST})
    add_test(NAME dirtSimple COMMAND dirtSimple)

    if (ENABLE_LLVM_BACKEND)
        add_executable(BlockTests "BlockTests.cpp")
        target_include_directories(BlockTests PRIVATE ${PNG_INCLUDE_DIR})
        target_link_libraries(BlockTests KSeExpr ${PNG_LIBRARIES})
        install(TARGETS BlockTests DESTINATION ${TEST_DEST})
        add_test(NAME BlockTests COMMAND BlockTests)
    endif()

    add_executable(VarBlockExample VarBlockExample.cpp)
    target_link_libraries(VarBlockExample KSeExpr)
    install(TARGETS VarBlockExample DESTINATION ${TEST_DEST})

    if (ENABLE_SLOW_TESTS)
        add_test(NAME VarBlockExample COMMAND VarBlockExample)
    endif()
endif()

=== src/utils/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

foreach(item eval listVar)
    add_executable("${item}" "${item}.cpp")
    target_link_libraries("${item}" ${SEEXPR_LIBRARIES})
    install(TARGETS "${item}" DESTINATION share/KSeExpr/utils)
endforeach()

if (ENABLE_QT5)
    add_executable(patterns patterns.cpp)
    target_link_libraries(patterns ${SEEXPR_LIBRARIES} ${SEEXPR_EDITOR_LIBRARIES})
    install(TARGETS patterns DESTINATION share/KSeExpr/utils)
endif()

=== src/demos/imageEditor/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

if(ENABLE_QT5)
    set(imageEditor_MOC_HDRS ImageEditorDialog.h)
    set(imageEditor_CPPS imageEditor.cpp)

    qt5_wrap_cpp(imageEditor_MOC_SRCS ${imageEditor_MOC_HDRS})

    add_executable(imageEditor2 ${imageEditor_CPPS} ${imageEditor_MOC_SRCS})

    target_link_libraries(imageEditor2 Qt5::Core
                                       Qt5::Gui
                                       Qt5::Widgets
                                       ${SEEXPR_LIBRARIES}
                                       ${SEEXPR_EDITOR_LIBRARIES})

    # Set application root dir for use inside the source code.
    target_compile_definitions(imageEditor2 PRIVATE IMAGE_EDITOR_ROOT="${CMAKE_INSTALL_PREFIX}")
    install(TARGETS imageEditor2 DESTINATION ${CMAKE_INSTALL_BINDIR})

    install(FILES fbm.se noisecolor1.se noisecolor2.se noise.se raytrace.se sinc.se
        DESTINATION share/KSeExpr/expressions)
endif()

=== src/demos/imageSynth/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2019 Disney Enterprises, Inc.
# SPDX-License-Identifier: LicenseRef-Apache-2.0
# SPDX-FileCopyrightText: 2020 L. E. Segovia <amy@amyspark.me>
# SPDX-License-Identifier: GPL-3.0-or-later

if (PNG_FOUND)
    add_executable(imageSynth2 "imageSynth.cpp")
    target_include_directories(imageSynth2 PRIVATE ${PNG_INCLUDE_DIR})
    target_link_libraries(imageSynth2 ${PNG_LIBRARIES} ${SEEXPR_LIBRARIES})
    install(TARGETS imageSynth2 DESTINATION bin)

    add_executable(imageSynthPaint3d2 "imageSynthForPaint3d.cpp")
    target_include_directories(imageSynthPaint3d2 PRIVATE ${PNG_INCLUDE_DIR})
    target_link_libraries(imageSynthPaint3d2 ${PNG_LIBRARIES} ${SEEXPR_LIBRARIES})
    install(TARGETS imageSynthPaint3d2 DESTINATION bin)
    install(DIRECTORY examples DESTINATION share/KSeExpr/demos/imageSynth
            USE_SOURCE_PERMISSIONS)
endif()

=== debian/changelog ===
kseexpr (4.0.4.0-4) unstable; urgency=medium

  * Update symbols files from the logs of buildds.

 -- Pino Toscano <pino@debian.org>  Thu, 28 Jul 2022 16:37:53 +0200

kseexpr (4.0.4.0-3) unstable; urgency=medium

  * Bump Standards-Version to 4.6.1, no changes required.
  * Update symbols files. (Closes: #1012962)

 -- Pino Toscano <pino@debian.org>  Thu, 28 Jul 2022 06:25:25 +0200

kseexpr (4.0.4.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Update symbols files from the logs of buildds.

 -- Pino Toscano <pino@debian.org>  Mon, 14 Feb 2022 08:31:44 +0100

kseexpr (4.0.4.0-1) experimental; urgency=medium

  * Initial packaging.

 -- Pino Toscano <pino@debian.org>  Sat, 08 Jan 2022 12:39:04 +0100

=== debian/control ===
Source: kseexpr
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Build-Depends: bison,
               cmake (>= 3.8.0~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.52.0~),
               flex,
               libgtest-dev <!nocheck>,
               libkf5i18n-dev (>= 5.52.0),
               libpng-dev <!nocheck>,
               pkg-kde-tools,
               python3:any,
               qtbase5-dev (>= 5.9.0~),
               qttools5-dev,
Standards-Version: 4.6.1
Uploaders: Pino Toscano <pino@debian.org>,
Rules-Requires-Root: no
Homepage: https://invent.kde.org/graphics/kseexpr
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/kseexpr
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/kseexpr.git

Package: libkseexpr-data
Section: misc
Architecture: all
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: embeddable expression evaluation engine - shared data
 SeExpr is an embeddable, arithmetic expression language that enables flexible
 artistic control and customization in creating computer graphics images.
 Example uses include procedural geometry synthesis, image synthesis,
 simulation control, crowd animation, and geometry deformation.
 .
 KSeExpr is a fork of SeExpr mainly used for Krita.
 .
 This package contains the data shared by the KSeExpr libraries.

Package: libkseexpr4
Architecture: any
Depends: libkseexpr-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: embeddable expression evaluation engine - shared library
 SeExpr is an embeddable, arithmetic expression language that enables flexible
 artistic control and customization in creating computer graphics images.
 Example uses include procedural geometry synthesis, image synthesis,
 simulation control, crowd animation, and geometry deformation.
 .
 KSeExpr is a fork of SeExpr mainly used for Krita.
 .
 This package contains the core shared library.

Package: libkseexprui4
Architecture: any
Depends: libkseexpr4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: embeddable expression evaluation engine - UI shared library
 SeExpr is an embeddable, arithmetic expression language that enables flexible
 artistic control and customization in creating computer graphics images.
 Example uses include procedural geometry synthesis, image synthesis,
 simulation control, crowd animation, and geometry deformation.
 .
 KSeExpr is a fork of SeExpr mainly used for Krita.
 .
 This package contains the UI shared library.

Package: libkseexpr-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libkseexpr4 (= ${binary:Version}),
         libkseexprui4 (= ${binary:Version}),
         qtbase5-dev,
         ${misc:Depends},
Description: development files for libreadstat library
 ReadStat is a command-line tool and MIT-licensed C library for reading files
 from popular stats packages.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTS=ON

execute_after_dh_auto_install:
	# do not ship the tests
	rm -rfv debian/tmp/usr/share/test/

=== debian/watch ===
version=4
https://download.kde.org/stable/kseexpr/([\d\.]+)/kseexpr-([\d\.]+)\.tar\.(?:gz|xz)

## kseexpr 4.0.4.0+p24.04+vstable+git20250903.0823

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20250903.0823-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 03 Sep 2025 08:23:49 +0000

kseexpr (4.0.4.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 16 Dec 2021 01:22:08 +0000

kseexpr (4.0.3.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 14 Jul 2021 01:22:04 +0000

kseexpr (4.0.2.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 13 Jul 2021 01:22:09 +0000

kseexpr (4.0.1.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 19 Nov 2020 01:22:10 +0000

kseexpr (4.0.0.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 02 Sep 2020 11:28:22 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20250926.0539

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20250926.0539-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 26 Sep 2025 05:39:59 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20251011.2324

=== src/KSeExpr/CMakeLists.txt ===
--- 
+++ 
@@ -82,7 +82,7 @@
     if (NOT APPLE)
         set_source_files_properties(interpreter.cpp PROPERTIES COMPILE_OPTIONS "-rdynamic")
     endif()
-    target_link_libraries(KSeExpr "dl")
+    target_link_libraries(KSeExpr ${CMAKE_DL_LIBS})
 else()
     add_library(KSeExpr STATIC ${KSeExpr_SOURCES} ${parser_cpp})
 endif()

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20251011.2324-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 11 Oct 2025 23:24:31 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure --  -DBUILD_DOC=ON -DBUILD_TESTS=OFF -DBUILD_UTILS=ON #-DENABLE_LLVM_BACKEND=ON -DCMAKE_CXX_STANDARD=17

=== debian/watch ===
version=4

opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/stable/@PACKAGE@/@ANY_VERSION@/@PACKAGE@-(.*)@ARCHIVE_EXT@

## kseexpr 4.0.4.0+p24.04+vstable+git20251015.0843

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20251015.0843-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 08:43:52 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20251023.0113

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 ## project name & version
 project(KSeExpr
-    VERSION "4.0.4.0"
+    VERSION "6.0.0.0"
     DESCRIPTION "An embeddable expression evaluation engine for Krita"
 )
 
@@ -65,8 +65,8 @@
 # Configuration options
 option(ENABLE_LLVM_BACKEND "Whether to build with LLVM backend" FALSE)
 add_feature_info(LLVMBackend ENABLE_LLVM_BACKEND "Build the LLVM backend of KSeExpr")
-option(ENABLE_QT5 "Whether to use Qt5" TRUE)
-add_feature_info(KSeExprUI ENABLE_QT5 "Build the KSeExprUI widget library")
+option(ENABLE_QT6 "Whether to use Qt6" TRUE)
+add_feature_info(KSeExprUI ENABLE_QT6 "Build the KSeExprUI widget library")
 option(BUILD_UTILS "Whether to build the utilities" FALSE)
 add_feature_info(Utils BUILD_UTILS "Build the utilities")
 option(BUILD_DEMOS "Whether to build the demos" FALSE)
@@ -82,17 +82,21 @@
 option(ENABLE_PERFORMANCE_STATS "Whether to print performance stats across KSeExpr" FALSE)
 add_feature_info(PerformanceStats ENABLE_PERFORMANCE_STATS "Print performance stats across KSeExpr")
 
+if (CMAKE_SYSTEM_NAME MATCHES "Windows")
+    set(USE_PREGENERATED_FILES TRUE)
+endif()
+
 # Package lookup
 
 find_package(Doxygen)
 set_package_properties(Doxygen PROPERTIES
                        TYPE OPTIONAL
                        PURPOSE "Needed to build the documentation")
-find_package(ECM 5.52.0 NO_MODULE)
+find_package(ECM 6.2.0 NO_MODULE)
 set_package_properties(ECM PROPERTIES
                        TYPE OPTIONAL
                        PURPOSE "Enables translations (if bundled) and automatic sanitizer support")
-find_package(KF5I18n 5.52.0)
+find_package(KF6I18n 6.2.0)
 set_package_properties(KF5I18n PROPERTIES
                        TYPE OPTIONAL
                        PURPOSE "Enables detection of fallback languages in KDE apps")
@@ -128,7 +132,7 @@
         include(ECMEnableSanitizers)
     endif()
 
-    if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/po")
+    if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/poqm")
         option(BUILD_TRANSLATIONS "Whether to include translations" TRUE)
         add_feature_info(i18n BUILD_TRANSLATIONS "Build and embed translations")
     endif ()
@@ -218,12 +222,12 @@
       FORCE)
 endif()
 
-if (ENABLE_QT5)
-    find_package(Qt5 5.9.0 COMPONENTS Core Gui Widgets REQUIRED)
+if (ENABLE_QT6)
+    find_package(Qt6 6.6.0 COMPONENTS Core Gui Widgets REQUIRED)
     set_package_properties(Qt5 PROPERTIES
                             TYPE REQUIRED
                             PURPOSE "Required if you're building KSeExprUI")
-    message(STATUS "Qt5 Enabled")
+    message(STATUS "Qt6 Enabled")
 endif()
 
 ## Make modules able to see seexpr library
@@ -241,7 +245,7 @@
 
 ## Traverse subdirectories
 add_subdirectory(src/KSeExpr)
-if (ENABLE_QT5)
+if (ENABLE_QT6)
     add_subdirectory(src/KSeExprUI)
 endif()
 if (BUILD_UTILS)

=== src/KSeExprUI/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
     list(APPEND CMAKE_MODULE_PATH "/usr/share/apps/cmake/modules")
 endif()
 
-if (Qt5_FOUND)
+if (TARGET Qt6::Widgets)
     # Adding Krita's definitions to make headers automatically compatible. -amyspark
     add_definitions(
         -DQT_USE_QSTRINGBUILDER
@@ -76,13 +76,13 @@
             Utils.cpp
     )
 
-    qt5_wrap_cpp(EDITOR_MOC_SRCS ${EDITOR_MOC_HDRS})
+    qt_wrap_cpp(EDITOR_MOC_SRCS ${EDITOR_MOC_HDRS})
 
     if (BUILD_TRANSLATIONS)
         include(ECMPoQmTools)
-        ecm_install_po_files_as_qm("${CMAKE_SOURCE_DIR}/po")
+        ecm_install_po_files_as_qm("${CMAKE_SOURCE_DIR}/poqm")
 
-        if (KF5I18n_FOUND)
+        if (TARGET KF6::I18n)
             add_definitions(-DKSeExpr_HAVE_I18N_FALLBACK_LANGUAGES_DETECTION)
         endif()
 
@@ -116,13 +116,13 @@
     target_link_libraries(KSeExprUI PUBLIC KSeExpr)
 
     target_link_libraries(KSeExprUI PUBLIC
-        Qt5::Core
-        Qt5::Gui
-        Qt5::Widgets
+        Qt::Core
+        Qt::Gui
+        Qt::Widgets
     )
 
-    if (KF5I18n_FOUND)
-        target_link_libraries(KSeExprUI PUBLIC KF5::I18n)
+    if (TARGET KF6::I18n)
+        target_link_libraries(KSeExprUI PUBLIC KF6::I18n)
     endif()
 
     ## Install library and includes

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20251023.0113-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 23 Oct 2025 01:13:37 +0000

=== debian/control ===
Source: kseexpr
Section: kde
Priority: optional
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               doxygen,
               flex,
               kf6-extra-cmake-modules,
               kf6-ki18n-dev,
               libedit-dev,
               libgtest-dev,
               libpng-dev,
               libzstd-dev,
               llvm-16-dev,
               pkg-kde-tools-neon,
               python3-dev,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-tools-dev
Standards-Version: 4.6.2
Homepage: http://www.kde.org/
Vcs-Git: https://invent.kde.org/neon/neon-packaging/kseexpr.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/kseexpr
Maintainer: Neon CI <neon@kde.org>

Package: libkseexpr6
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libkseexpr-data (<< ${source:Version}~ciBuild),
        libkseexpr3 (<< 4.0.1),
        libkseexpr4 (<< ${source:Version}~ciBuild),
        libkseexpr4.0.2.0 (<< 4.0.3),
        libkseexpr4010 (<< 4.0.2),
        libkseexprui3 (<< 4.0.1),
        seexpr (<< 4)
Replaces: libkseexpr-data (<< ${source:Version}~ciBuild),
          libkseexpr3 (<< 4.0.1),
          libkseexpr4 (<< ${source:Version}~ciBuild),
          libkseexpr4.0.2.0 (<< 4.0.3),
          libkseexpr4010 (<< 4.0.2),
          libkseexprui3 (<< 4.0.1),
          seexpr (<< 4)
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Library.

Package: libkseexprui6
Architecture: any
Breaks: libkseexpr3 (<< 4.0.1),
        libkseexprui3 (<< 4.0.1),
        libkseexprui4 (<< ${source:Version}~ciBuild),
        libkseexprui4.0.2.0 (<< 4.0.3),
        libkseexprui4010 (<< 4.0.2),
        seexpr (<< 4)
Replaces: libkseexpr3 (<< 4.0.1),
          libkseexprui3 (<< 4.0.1),
          libkseexprui4 (<< ${source:Version}~ciBuild),
          libkseexprui4.0.2.0 (<< 4.0.3),
          libkseexprui4010 (<< 4.0.2),
          seexpr (<< 4)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita.
 .
 UI library.

Package: libkseexpr-dev
Architecture: any
Depends: libkseexpr6 (= ${binary:Version}),
         libkseexprui6 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: kseexpr-dev,
        libkseexpr3 (<< 4.0.1),
        libkseexprui3 (<< 4.0.1),
        seexpr (<< 4)
Replaces: kseexpr-dev,
          libkseexpr3 (<< 4.0.1),
          libkseexprui3 (<< 4.0.1),
          seexpr (<< 4)
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Development files.

Package: libkseexpr-doc
Architecture: all
Depends: ${misc:Depends}
Priority: optional
Section: doc
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Documentation files.

Package: libkseexpr-data
Architecture: any
Depends: ${misc:Depends}
Section: oldlibs
Priority: optional
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Transitional dummy package.

Package: seexpr
Architecture: all
Depends: libkseexpr3, libkseexprui3, ${misc:Depends}, ${shlibs:Depends}
Priority: optional
Section: oldlibs
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Transitional dummy package.

Package: libkseexprui3
Architecture: all
Depends: ${misc:Depends}
Priority: optional
Section: oldlibs
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Transitional dummy package.

Package: libkseexpr3
Architecture: all
Depends: ${misc:Depends}
Priority: optional
Section: oldlibs
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Transitional dummy package.

Package: libkseexpr4010
Architecture: any
Depends: ${misc:Depends}
Priority: optional
Section: oldlibs
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Transitional dummy package.

Package: libkseexprui4010
Architecture: any
Depends: ${misc:Depends}
Priority: optional
Section: oldlibs
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita.
 .
 Transitional dummy package.

Package: libkseexpr4.0.2.0
Architecture: any
Depends: ${misc:Depends}
Section: oldlibs
Priority: optional
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Transitional dummy package.

Package: libkseexprui4.0.2.0
Architecture: any
Section: oldlibs
Priority: optional
Depends: ${misc:Depends}
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita.
 .
 Transitional dummy package.

Package: libkseexpr4
Architecture: any
Depends: ${misc:Depends}
Section: oldlibs
Priority: optional
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita
 .
 Transitional dummy package.

Package: libkseexprui4
Architecture: any
Section: oldlibs
Priority: optional
Depends: ${misc:Depends}
Description: Fork of Walt Disney Animation Studios' SeExpr
 Fork of Walt Disney Animation Studios' SeExpr for Krita.
 .
 Transitional dummy package.

## kseexpr 4.0.4.0+p24.04+vstable+git20251031.0732

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20251031.0732-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 31 Oct 2025 07:32:36 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20251109.0150

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20251109.0150-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 09 Nov 2025 01:50:40 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20251113.0611

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20251113.0611-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 13 Nov 2025 06:11:05 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20260102.1120

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20260102.1120-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 02 Jan 2026 11:20:45 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20260107.0656

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20260107.0656-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 07 Jan 2026 06:56:54 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20260116.0907

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20260116.0907-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 16 Jan 2026 09:07:06 +0000

## kseexpr 4.0.4.0+p24.04+vstable+git20260122.1234

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vstable+git20260122.1234-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 22 Jan 2026 12:34:09 +0000

## kseexpr 4.0.4.0+p24.04+vunstable+git20251020.0234

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vunstable+git20251020.0234-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 02:34:22 +0000

## kseexpr 4.0.4.0+p24.04+vunstable+git20251030.0052

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vunstable+git20251030.0052-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 30 Oct 2025 00:52:59 +0000

## kseexpr 4.0.4.0+p24.04+vunstable+git20251111.0353

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vunstable+git20251111.0353-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 11 Nov 2025 03:53:31 +0000

## kseexpr 4.0.4.0+p24.04+vunstable+git20260123.0330

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vunstable+git20260123.0330-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 23 Jan 2026 03:30:59 +0000

## kseexpr 4.0.4.0+p24.04+vunstable+git20260201.0548

=== debian/changelog ===
kseexpr (4.0.4.0+p24.04+vunstable+git20260201.0548-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 01 Feb 2026 05:48:07 +0000
